local ADDON, data = ...

local SPELL_IDS = {
	ArcaneCharge = 36032,
}

------------------------------------------------------------------

local function GetAuraData (aura)
    -- Returns time remaining, value, duration
    local name, _, _, _, _, duration, expires, _, _, _, _, _, _, _, value2 = UnitAura ('player', aura)
    if name==nil then
        return 0,0
    else
        return expires-GetTime(), value2, duration
    end
end

------------------------------------------------------------------

local function ShortNumber (n)
    if n<1000 then
        return tostring(n)
    elseif n<1000000 then
        return tostring(floor((n+500)/1000))..'K'
    else
        return tostring(floor((n+500000)/1000000))..'M'
    end
end

------------------------------------------------------------------

PlayerAuras = {}
local function ScanPlayerAuras ()
    -- Fills the PlayerAuras table with aura data. The keys are spell IDs, and each value is a table containing name, duration, expires, value2
    local i=1
    PlayerAuras = {}
	local name, count, duration, expires, spellID, value2, _
    
    -- Scan buffs
    while true do
        local name,_,_,count,_, duration, expires,_,_,_,spellID,_,_,_, value2 = UnitBuff('player', i)
        i = i+1
        if name then
            PlayerAuras[spellID] = {duration=duration, expires=expires, value2=value2, name=name, count=count}
        else
            break
        end        
    end
    
	i=1
    -- Scan debuffs
    while true do
        local name,_,_,count,_, duration, expires,_,_,_,spellID,_,_,_, value2 = UnitDebuff('player', i)
        i = i+1
        if name then
            PlayerAuras[spellID] = {duration=duration, expires=expires, value2=value2, name=name, count=count}
	    else
            break
        end        
    end
end


------------------------------------------------------------------

local _,_, class = UnitClass('player')
if class==8 then
	f = CreateFrame ("StatusBar", 'frmArcira', self)
	f:SetSize(160,80)
	f:SetPoint ("LEFT", UIParent, "LEFT", 50,0)
	f:SetStatusBarTexture('Interface\\addons\\'..ADDON..'\\bar')
	f:SetMinMaxValues (-1,5)
	f:SetBackdrop ({
        bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		insets = {left = 20,right = 20,top = 30,bottom = 25}
    })

	-- Frame for the bar
	f.frame = CreateFrame ("Frame", nil, f)
	f.frame:SetAllPoints (f)
	f.frame:SetBackdrop ({
		bgFile='Interface\\addons\\'..ADDON..'\\frame'
	})

	-- Glowy effect
	f.glow = CreateFrame ("Frame", nil, f)
	f.glow:SetAllPoints (f)
	f.glow:SetBackdrop ({
		bgFile='Interface\\addons\\'..ADDON..'\\glow'
	})
	f.glow:SetFrameLevel (15) -- I have no idea how this thing works -.o
	f.glow:Hide ()

	function f:Set (v) 
		local n = 0.7 + 0.075*v
		self.frame:SetBackdropColor (n,n,n,1)
		self:SetStatusBarColor (n,n,n,1)
		if v==4 then
			self.glow:Show ()
		else
			self.glow:Hide ()
		end
		self:SetValue (v)
	end
	f:Set (0)
	
	-- Make movable
    f:SetMovable (true)
    f:SetUserPlaced (true)
    f:SetClampedToScreen (true)
    f:EnableMouse (true)
    f:SetScript("OnMouseDown", function(self, button)
		if button=='LeftButton' then
			self:StartMoving ()
		end
	end)
	f:SetScript("OnMouseUp", function(self)
		self:StopMovingOrSizing ()
	end)
    
    
	f:RegisterUnitEvent ('UNIT_AURA', 'player')
	f:SetScript ('OnEvent', function (self, e)
		if e=='UNIT_AURA' then
			ScanPlayerAuras ()
			if PlayerAuras[SPELL_IDS.ArcaneCharge] then
				self:Set (PlayerAuras[SPELL_IDS.ArcaneCharge].count)
			else
				self:Set (0)
			end
		end
	end)
    
end
